/// tksmdi.h
///
/// (c) 2007-2008 Bastian Spiegel <bs@tkscript.de>
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///
/// changed: ?????2007, ..., 31Aug2008
///

#ifndef __TKSMDI_H__
#define __TKSMDI_H__


YG("smdi");


// ---------------------------------------------------------------------------- SMDI_SampleHeader
YC class _SMDI_SampleHeader : public YAC_Object {
   //
   // Also see SMDI_SampleHeader C struct below
   //
public:
   sSI sample_nr;
   sSI bits_per_word;
   sSI num_channels;
   sSI sample_period; // nanosec, e.g. (unsigned int)(1000000000.0/44100.0)
   sSI sample_length;
   sSI loop_ctrl;
   sSI loop_start;
   sSI loop_end;
   sSI pitch_int;
   sSI pitch_frac;
   YAC_String *name;

public:
   YAC(_SMDI_SampleHeader);

   _SMDI_SampleHeader();
   ~_SMDI_SampleHeader();

   YM sSI  getSampleNr (void);
   YM void setSampleNr (sSI _sampleNr);

   YM sSI  getBitsPerWord (void);
   YM void setBitsPerWord (sSI _bits);

   YM sSI  getNumChannels (void);
   YM void setNumChannels (sSI _num);

   YM sSI  getSamplePeriod (void);
   YM void setSamplePeriod (sSI _per);

   YM sSI  getSampleLength (void);
   YM void setSampleLength (sSI _len);

   YM sSI  getLoopCtrl (void);
   YM void setLoopCtrl (sSI _loopCtrl);

   YM sSI  getLoopStart (void);
   YM void setLoopStart (sSI _loopStart);

   YM sSI  getLoopEnd   (void);
   YM void setLoopEnd   (sSI _loopEnd);

   YM sSI  getPitchInt  (void);
   YM void setPitchInt  (sSI _pitchInt);

   YM sSI  getPitchFrac (void);
   YM void setPitchFrac (sSI _pitchFrac);

   YM YAC_Object *getName (void);
   YM void        setName (YAC_Object *_name);
};



// ---------------------------------------------------------------------------- SMDI
YC class _SMDI : public YAC_Object {
   public:

      YAC(_SMDI);

      YM sBool _init                (void);
      YM void  _exit                (void);
      YM sBool rescanSCSIBus        (sSI _adapterNr);
      YM void  inquiry              (sSI _adapterNr, sSI _targetNr);
      YM void  printAdapterInfo     (sSI _adapterNr);
      YM sBool uploadSample         (sSI _adapterNr, sSI _targetNr, YAC_Object *_header, YAC_Object *_sampleBuf); // Sample# is taken from header. Unfortunately the Sample# is ignored by some samplers, e.g. Yamaha AxK..
      YM sBool downloadSampleHeader (sSI _adapterNr, sSI _targetNr, sSI _sampleNr, YAC_Object *_header);
      YM sBool downloadSample       (sSI _adapterNr, sSI _targetNr, sSI _sampleNr, YAC_Object *_sampleBuf);
      YM sBool deleteSample         (sSI _adapterNr, sSI _targetNr, sSI _sampleNr); // Unfortunately not implemented on all samplers, e.g. *NOT* on Yamaha AxK..
};


#endif // __TKSMDI_H__
